<?php
/**
 * Checkout coupon form
 *
 * @author 		WooThemes
 * @package 	WooCommerce/Templates
 * @version     3.4.4
 */

defined( 'ABSPATH' ) || exit;

if ( ! wc_coupons_enabled() ) { // @codingStandardsIgnoreLine.
	return;
}
?>

<div class="checkout_coupon_box">

	<div class="shopkeeper_checkout_coupon">
		<?php echo apply_filters( 'woocommerce_checkout_coupon_message', esc_html__( 'Have a coupon?', 'woocommerce' ) . ' <a href="#" class="showcoupon">' . esc_html__( 'Click here to enter your code', 'woocommerce' ) . '</a>' ); ?>
	</div>

	<div class="row">
		<form class="checkout_coupon woocommerce-form-coupon" method="post" style="display:none">
			<div class="checkout_coupon_inner">
				<input type="text" name="coupon_code" class="input-text" placeholder="<?php echo esc_attr( 'Coupon code', 'woocommerce' ); ?>" id="coupon_code" value="" />
				<button type="submit" class="button" name="apply_coupon" value="<?php echo esc_attr( 'Apply coupon', 'woocommerce' ); ?>"><?php esc_html_e( 'Apply coupon', 'woocommerce' ); ?></button>
				<div class="clear"></div>
			</div>
		</form>
	</div><!-- .row-->

</div><!-- .checkout_coupon_box-->
